<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<app-role-checker [allowedRoles]="[admin, nodeOperator]">
  <ng-template let-authorized>
    <div class="w-full h-full section flex flex-col">
      <div class="flex flex-col gap-4 items-end justify-end pb-6 mt-3">
        <p-button
          label="New credential"
          icon="pi pi-plus"
          (onClick)="newCredential()"
          [disabled]="!authorized"
        ></p-button>
        <app-info *ngIf="!authorized" message="Insufficient role to create new credentials"></app-info>
      </div>
      <div class="w-full grow">
        <ng-container *ngLet="initializing$ | async as initializing">
          <app-table-skeleton *ngIf="initializing"> </app-table-skeleton>
          <ng-container *ngIf="!initializing">
            <ng-container *ngLet="credentials$ | async as credentials">
              <p-table
                *ngIf="credentials"
                [value]="credentials"
                styleClass="p-datatable-striped h-full"
                [scrollable]="true"
                [scrollHeight]="authorized ? 'calc(100svh - 236px)' : 'calc(100svh - 264px)'"
              >
                <ng-template pTemplate="header">
                  <tr>
                    <th>UID</th>
                    <th>Client ID</th>
                    <th>Permissions</th>
                    <th>Expiration</th>
                    <th></th>
                    <th></th>
                  </tr>
                </ng-template>
                <ng-template pTemplate="body" let-credential>
                  <ng-container *ngLet="convertTtl(credential.created, credential.ttl) as ttl">
                    <tr>
                      <td>
                        <app-long-id [id]="credential.uid"></app-long-id>
                      </td>
                      <td>
                        <app-long-id [id]="credential.clientid"></app-long-id>
                      </td>
                      <td>
                        <div class="flex items-center gap-1">
                          <p-tag
                            [value]="permission"
                            *ngFor="let permission of credential.permissions"
                            [severity]="
                              permission == 'ADAPTER'
                                ? 'secondary'
                                : permission == 'LOCAL_EVENT_LISTENER'
                                ? 'warning'
                                : 'info'
                            "
                          >
                          </p-tag>
                        </div>
                      </td>
                      <td>
                        <app-expiration [credential]="credential"></app-expiration>
                      </td>
                      <td>
                        <app-options [credential]="credential"></app-options>
                      </td>
                      <td>
                        <div class="w-full flex justify-end">
                          <div class="text-sm text-text-300">
                            <div>created: {{ credential.created | applyLocalTzPipe | date : 'medium' }}</div>
                          </div>
                        </div>
                      </td>
                    </tr>
                  </ng-container>
                </ng-template>
                <ng-template pTemplate="emptymessage">
                  <tr>
                    <td colspan="6">
                      <div class="w-full h-full flex flex-col items-center gap-4 py-2 justify-center">
                        <div class="text-lg font-semibold text-text-300">
                          <app-sad-face></app-sad-face>
                        </div>
                        <div class="text-text-300">No credentials</div>
                      </div>
                    </td>
                  </tr>
                </ng-template>
              </p-table>
            </ng-container>
          </ng-container>
        </ng-container>
      </div>
    </div>
  </ng-template>
</app-role-checker>
